<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <xsl:output method="html"/>
    <xsl:template match="/Paradigms">
        <html>
            <xsl:text>&#x0A;</xsl:text>
            <head>
                <title><xsl:value-of select="@title"/></title>  <!--Ought to have a default -->
            </head>
            <xsl:text>&#x0A;</xsl:text>
            <body>
                <xsl:for-each select="POS">
                    <h1 align="center">
                        <title><xsl:value-of select="./@name"/></title><xsl:text>&#x0A;</xsl:text>
                    </h1>
                    <xsl:for-each select="./Paradigm">
                        <p>
                        <table border="2" width="80%" cols="2">
                            <caption align="top"><strong><xsl:value-of select="@constant_features"/> paradigm of <xsl:value-of select="../@stem"/> with <xsl:value-of select="./@name"/></strong></caption>
                            <xsl:for-each select="./Cell">
                                <xsl:text>&#x0A;</xsl:text>
                                <tr>
                                    <td width="40%"><xsl:value-of select="PosFeatures"/></td>
                                    <!--Remove the trailing newline after the last Wordform.  This is easier said than done...Ideally, we could
                                         strip the trailing whitespace with a function like Python's "rstrip()."  But xslt does not have such a function
                                         (and the strip-space directive converts ALL whitespace to space chars, which we don't want to do: we want
                                         the other newlines after wordforms to remain).  So instead, we remove a certain number of chars at the end
                                         of the wordforms string.  The value of '8', used below to determine how many chars to remove, is determined
                                         by the amount of leading space inserted before the close </Wordforms> tag by GenParadigms.py.  We could
                                         omit that space, and just remove a single char (which would be the newline after the final wordform),
                                         except that the xfst 'echo' cmd, which produces the tag, already inserts a single space char...-->
                                    <td width="60%"><pre><xsl:value-of select="substring(Wordforms, 1, (string-length(Wordforms) - 8))"/></pre></td>
                                </tr>
                            </xsl:for-each>
                        </table>
                        </p>
                        <!--Add some extra space before the next table: -->
                        <br/>
                    </xsl:for-each>
                </xsl:for-each>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>
